gtkmm: Gdk::DeviceWithPad Class Reference

gtkmm 4.18.0

Public Member Functions | Protected Member Functions | List of all members
Gdk::DeviceWithPad Class Reference

A Gdk::DeviceWithPad is a Gdk::Device that implements the Gdk::DevicePad interface. More...

`#include <gdkmm/devicewithpad.h>`

Inheritance diagram for Gdk::DeviceWithPad:
[legend]

## Public Member Functions
| DeviceWithPad (DeviceWithPad && src) noexcept
DeviceWithPad & | operator= (DeviceWithPad && src) noexcept
| ~DeviceWithPad () noexcept override
Public Member Functions inherited from Gdk::Device
| Device (Device && src) noexcept
Device & | operator= (Device && src) noexcept
| ~Device () noexcept override
GdkDevice * | gobj ()
| Provides access to the underlying C GObject.
const GdkDevice * | gobj () const
| Provides access to the underlying C GObject.
GdkDevice * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ustring | get_name () const
| The name of the device, suitable for showing in a user interface.
bool | get_has_cursor () const
| Determines whether the pointer follows device motion.
InputSource | get_source () const
| Determines the type of the device.
Glib::RefPtr< Display > | get_display ()
| Returns the `Gdk::Display` to which device pertains.
Glib::RefPtr< const Display > | get_display () const
| Returns the `Gdk::Display` to which device pertains.
Glib::RefPtr< Surface > | get_surface_at_position (double & win_x, double & win_y)
| Obtains the surface underneath device, returning the location of the device in win_x and win_y.
Glib::RefPtr< const Surface > | get_surface_at_position (double & win_x, double & win_y) const
| Obtains the surface underneath device, returning the location of the device in win_x and win_y.
Glib::RefPtr< Surface > | get_surface_at_position ()
| Obtains the surface underneath the device.
Glib::RefPtr< const Surface > | get_surface_at_position () const
| Obtains the surface underneath the device.
Glib::ustring | get_vendor_id () const
| Returns the vendor ID of this device.
Glib::ustring | get_product_id ()
| Returns the product ID of this device.
Glib::RefPtr< Seat > | get_seat ()
| Returns the `Gdk::Seat` the device belongs to.
Glib::RefPtr< const Seat > | get_seat () const
| Returns the `Gdk::Seat` the device belongs to.
guint | get_num_touches () const
| Retrieves the number of touch points associated to device.
Glib::RefPtr< DeviceTool > | get_device_tool ()
| Retrieves the current tool for device.
Glib::RefPtr< const DeviceTool > | get_device_tool () const
| Retrieves the current tool for device.
bool | get_caps_lock_state () const
| Retrieves whether the Caps Lock modifier of the keyboard is locked.
bool | get_num_lock_state () const
| Retrieves whether the Num Lock modifier of the keyboard is locked.
bool | get_scroll_lock_state () const
| Retrieves whether the Scroll Lock modifier of the keyboard is locked.
ModifierType | get_modifier_state () const
| Retrieves the current modifier state of the keyboard.
Pango::Direction | get_direction () const
| Returns the direction of effective layout of the keyboard.
bool | has_bidi_layouts () const
| Determines if layouts for both right-to-left and left-to-right languages are in use on the keyboard.
guint32 | get_timestamp () const
| Returns the timestamp of the last activity for this device.
int | get_active_layout_index () const
| Retrieves the index of the active layout of the keyboard.
std::vector< Glib::ustring > | get_layout_names () const
| Retrieves the names of the layouts of the keyboard.
bool | has_device_pad () const
| Checks if this Device instance is a DeviceWithPad.
Glib::RefPtr< DeviceWithPad > | device_with_pad_cast ()
| Casts this Device instance to a DeviceWithPad, if possible.
Glib::RefPtr< const DeviceWithPad > | device_with_pad_cast () const
| Casts this Device instance to a DeviceWithPad, if possible.
Glib::SignalProxy< void()> | signal_changed ()
Glib::SignalProxy< void(const Glib::RefPtr< DeviceTool > &)> | signal_tool_changed ()
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Display > > | property_display () const
| The `Gdk::Display` the `Gdk::Device` pertains to.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The device name.
Glib::PropertyProxy_ReadOnly< InputSource > | property_source () const
| Source type for the device.
Glib::PropertyProxy_ReadOnly< bool > | property_has_cursor () const
| Whether the device is represented by a cursor on the screen.
Glib::PropertyProxy_ReadOnly< guint > | property_n_axes () const
| Number of axes in the device.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_vendor_id () const
| Vendor ID of this device.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_product_id () const
| Product ID of this device.
Glib::PropertyProxy< Glib::RefPtr< Seat > > | property_seat ()
| `Gdk::Seat` of this device.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Seat > > | property_seat () const
| `Gdk::Seat` of this device.
Glib::PropertyProxy_ReadOnly< guint > | property_num_touches () const
| The maximal number of concurrent touches on a touch device.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< DeviceTool > > | property_tool () const
| The `Gdk::DeviceTool` that is currently used with this device.
Glib::PropertyProxy_ReadOnly< Pango::Direction > | property_direction () const
| The direction of the current layout.
Glib::PropertyProxy_ReadOnly< bool > | property_has_bidi_layouts () const
| Whether the device has both right-to-left and left-to-right layouts.
Glib::PropertyProxy_ReadOnly< bool > | property_caps_lock_state () const
| Whether Caps Lock is on.
Glib::PropertyProxy_ReadOnly< bool > | property_num_lock_state () const
| Whether Num Lock is on.
Glib::PropertyProxy_ReadOnly< bool > | property_scroll_lock_state () const
| Whether Scroll Lock is on.
Glib::PropertyProxy_ReadOnly< ModifierType > | property_modifier_state () const
| The current modifier state of the device.
Glib::PropertyProxy_ReadOnly< int > | property_active_layout_index () const
| The index of the keyboard active layout of a `Gdk::Device`.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_layout_names () const
| The names of the keyboard layouts of a `Gdk::Device`.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from Gdk::DevicePad
| DevicePad (DevicePad && src) noexcept
DevicePad & | operator= (DevicePad && src) noexcept
| ~DevicePad () noexcept override
GdkDevicePad * | gobj ()
| Provides access to the underlying C GObject.
const GdkDevicePad * | gobj () const
| Provides access to the underlying C GObject.
int | get_n_groups () const
| Returns the number of groups this pad device has.
int | get_group_n_modes (int group_idx) const
| Returns the number of modes that group may have.
int | get_n_features (Feature feature) const
| Returns the number of features a tablet pad has.
int | get_feature_group (Feature feature, int feature_idx) const
| Returns the group the given feature and idx belong to.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Protected Member Functions
| DeviceWithPad (GdkDevice * castitem)
Protected Member Functions inherited from Gdk::Device
| Device ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gdk::DevicePad
| DevicePad ()
| You should derive from this class to use it.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from Gdk::DevicePad
enum class | Feature { Feature::BUTTON , Feature::RING , Feature::STRIP }
| A pad feature. More...
Static Public Member Functions inherited from Gdk::Device
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gdk::DevicePad
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Related Symbols inherited from Gdk::Device
Glib::RefPtr< Gdk::Device > | wrap (GdkDevice * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gdk::DevicePad
Glib::RefPtr< Gdk::DevicePad > | wrap (GdkDevicePad * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Gdk::DeviceWithPad is a Gdk::Device that implements the Gdk::DevicePad interface.

Use Gdk::Device::has_device_pad() to check if a Gdk::Device is in fact a Gdk::DeviceWithPad. Use Gdk::Device::device_with_pad_cast() to get a Glib::RefPtr<Gdk::DeviceWithPad>.

## Constructor & Destructor Documentation

## ◆ DeviceWithPad() [1/2]

Gdk::DeviceWithPad::DeviceWithPad | ( | GdkDevice * | castitem | ) |
| explicitprotected

## ◆ DeviceWithPad() [2/2]

Gdk::DeviceWithPad::DeviceWithPad | ( | DeviceWithPad && | src | ) |
| noexcept

## ◆ ~DeviceWithPad()

Gdk::DeviceWithPad::~DeviceWithPad | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ operator=()

DeviceWithPad & Gdk::DeviceWithPad::operator= | ( | DeviceWithPad && | src | ) |
| noexcept